<xml style="display:none">
<!--
///<file name="constructions_view.xsl" type="xslStylesheet">
///<desc>template viewer ISOVER constructions 
/// from XML filtered file 'constructions.xml'
///</desc>
-->
<xsl:stylesheet 
  xmlns="http://www.w3.org/1999/xhtml"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:xs="http://www.w3.org/2001/XMLSchema"
	xmlns:svg="http://www.w3.org/2000/svg"
	xmlns:xlink="http://www.w3.org/1999/xlink" 
	xmlns:kres="http://www.sbmintegral.sk/docdefs/kres"
	xml:lang="sk"
  version="1.0"
 >
<xsl:output encoding="utf-8" method="xml" indent="yes" omit-xml-declaration="yes" />
<xsl:strip-space elements="*"/>


<!-- ______________________________________________________________________________________ -->
	<xsl:param name="title" select="'ISOVER constructions'" />
	<xsl:param name="buildsel" select="'buttons'" />	<!-- selector, buttons -->
  
  
  <xsl:template match="/">
    
<xsl:text disable-output-escaping='yes'>&lt;!DOCTYPE html></xsl:text>
<html 
	xmlns="http://www.w3.org/1999/xhtml" 
	xmlns:svg="http://www.w3.org/2000/svg"
	xmlns:xlink="http://www.w3.org/1999/xlink" 
	xmlns:kres="http://www.sbmintegral.sk/docdefs/kres"
	xml:lang="sk"
>
 <head>
	<meta charset="utf-8"/>
   <meta http-equiv="Pragma" content="no-cache"/>
   <meta http-equiv="Expires" content="-1"/>
   <title><xsl:value-of select="$title" /></title> 
   
<link href="../css/constructions_view.css" media="screen" rel="stylesheet" type="text/css"/>

<script type="text/javascript" src="../js/jquery-2.0.3.js"></script>
<script type="text/javascript" src="../js/jquery.svg.pan.zoom.js"></script>
<script type="text/javascript" src="../js/constructions_view.js"></script> 
   
 </head>
<body>
  <h1><xsl:value-of select="$title" /></h1>
    <div id="constructions">
      <table border="1" style="width:540px;table-layout:fixed">
		<colgroup>
          <col style="width: 90px;"/>
          <col style="width: 90px;"/>
          <col style="width: 90px;"/>
          <col style="width: 90px;"/>
          <col style="width: 90px;"/>
          <col style="width: 90px;"/>
		</colgroup>
<!--        <thead>
          <tr><td></td><td></td><td></td><td></td></tr>
        </thead>	-->
        <tbody>
	      <xsl:apply-templates select="ConstructionCollection/item" />
        </tbody>
      </table>
    </div>
  
</body>
  <script type="text/javascript">
$('#constructions').find('svg').svgPanZoom( {
	maxZoom : 100
} )  
  </script>
</html>
    
  </xsl:template>
  
  
  <!--
///<template name="blanks">pre nepokryte uzly a atributy nevypisuj default !!! 
--> <!--!   B L A N K S   -->
  <xsl:template match="text()">
  </xsl:template>
  <xsl:template match="@*">
  </xsl:template>
  <xsl:template match="*">
  </xsl:template>
  <!--///</template>-->
  
	<xsl:template name="string-replace-all">
	  <xsl:param name="text" />
	  <xsl:param name="replace" />
	  <xsl:param name="by" />
	  <xsl:choose>
		<xsl:when test="contains($text, $replace)">
		  <xsl:value-of select="substring-before($text,$replace)" />
		  <xsl:value-of select="$by" />
		  <xsl:call-template name="string-replace-all">
			<xsl:with-param name="text" select="substring-after($text,$replace)" />
			<xsl:with-param name="replace" select="$replace" />
			<xsl:with-param name="by" select="$by" />
		  </xsl:call-template>
		</xsl:when>
		<xsl:otherwise>
		  <xsl:value-of select="$text" />
		</xsl:otherwise>
	  </xsl:choose>
	</xsl:template>
  
  <xsl:template name="tokenize_options">
    <xsl:param name="text" select="."/>
    <xsl:param name="separator" select="','"/>
    <xsl:choose>
      <xsl:when test="not(contains($text, $separator))">
        <option>
          <xsl:value-of select="normalize-space($text)"/>
        </option>
      </xsl:when>
      <xsl:otherwise>
        <option>
          <xsl:value-of select="normalize-space(substring-before($text, $separator))"/>
        </option>
        <xsl:call-template name="tokenize_options">
          <xsl:with-param name="text" select="substring-after($text, $separator)"/>
          <xsl:with-param name="separator" select="$separator"/>
        </xsl:call-template>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  
  <xsl:template match="@* | node()" mode="kopirka">
    <xsl:copy>
      <xsl:apply-templates select="@* | node()"/>
    </xsl:copy>
  </xsl:template>
  
  
  <xsl:template match="ConstructionCollection/item" >
  <xsl:if test="position() &lt; 100000">
    <tr>
      <td colspan="3">
        <div>
<!--          <span class="lab">id:</span><span><xsl:value-of select="construction_id"/></span>	
          <br/>
-->
		  <div class="limwidth">
			<span class="pop"><xsl:value-of select="construction_lang"/></span>
		  </div>
          <a href="{url1}" target="isoverlink"><xsl:value-of select="linktext1"/></a>
          <br/>
          <span class="summary"><xsl:value-of select="construction_summary_FS"/></span>
<!--          
          <br/>
          <span class="lab">psi:</span><span><xsl:value-of select="psi_value"/></span>
          <br/>
-->
		  <xsl:choose>
			<xsl:when test="$buildsel='selector'">
              <br/>
			  <select>
				<xsl:apply-templates select="*[starts-with(name(),'buildup_')]" mode="selector" />
			  </select>
			  <input type="button" value="Skladba" onclick="buildup_opener(event,1);" />
			</xsl:when>
			<xsl:when test="$buildsel='buttons'">
			  <xsl:apply-templates select="*[starts-with(name(),'buildup_')]" mode="buttons" />
			</xsl:when>
			<xsl:otherwise>
			</xsl:otherwise>
		  </xsl:choose>
        </div>
      </td>
      <td colspan="3">
        <div>
			<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink"
				viewBox="0 0 800 600" version="1.1" width="270">
				<image alt="construct" xlink:href="{upload_5}" x="0" y="0" width="800px" height="600px"/>
			</svg>
        </div>
      </td>
<!--
      <td>
        <div>
          <span class="pop"><xsl:value-of select="construction_lang"/></span>
          <br/>
          <a href="{url1}" target="isoverlink"><xsl:value-of select="linktext1"/></a>
        </div>
      </td>
      <td>
        <div>
          <img alt="termika" src="{upload_4}" width="200px"/>
        </div>
      </td>
      <td class="__ass_3D">
        <select size="10" multiple="multiple">
		<option>1</option>
		<option>2</option>
		<option>3</option>
		<option>4</option>
		<option>5</option>
		<option>6</option>
		<option>7</option>
		<option>8</option>
		<option>9</option>
		<option>10</option>
        </select>
      </td>
-->
    </tr>
    <xsl:apply-templates select="*[starts-with(name(),'buildup_')]" />
  </xsl:if>
  </xsl:template>

  <xsl:template match="*[starts-with(name(),'buildup_')]" mode="selector">
    <xsl:if test="layers">
      <option><xsl:value-of select="name()"/></option>
    </xsl:if>
  </xsl:template>

  <xsl:template match="*[starts-with(name(),'buildup_')]" mode="buttons">
    <xsl:if test="layers">
	  <br/>
      <input type="button" value="{name()}" onclick="buildup_opener(event,2);" />
    </xsl:if>
  </xsl:template>

  <xsl:template match="*[starts-with(name(),'buildup_')]">
    <xsl:if test="layers">
    <tr class="buildup" data-buildup="{name()}" >	<!-- style="display:none" -->
      <td>
        <span class="lab">skladba</span><span><xsl:value-of select="translate(substring-after(name(),'buildup_'),
            'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')" /></span>
        <br/>
        <span class="lab">u:</span><span><xsl:value-of select="u_value"/></span>
        <br/>
<!--        <span class="lab">3D:</span><span><xsl:value-of select="asignment3D"/></span>		-->
        <br/>
        <input type="button" value="Zavri" onclick="buildup_opener(event,0);" />
        <input type="button" value="Vyber" onclick="buildup_opener(event,3);" />
      </td>
      <td colspan="5">
        <table border="1">
		  <thead>
			<th class="position">nr.</th>			
			<th class="description"><xsl:value-of select="../construction_summary_FS"/></th>			
			<th class="thickness">hrúbka</th>	
<!--			
			  <xsl:apply-templates 
                select="layers/item[1]/*[not(starts-with(name(),'linktext')) and not(starts-with(name(),'url')) and (name()!='layer_thickness') and (name()!='layer_thickness_unit') and (name()!='product_description') and (name()!='position') and (name()!='layer_id') ]" 
				mode="thvalue" />
-->				
			<th class="density">hustota</th>	
		  </thead>
          <tbody>
            <xsl:apply-templates select="layers/item" />
          </tbody>
        </table>
      </td>
    </tr>
    </xsl:if>
  </xsl:template>
      
  <xsl:template match="layers/item">
    <tr>
      <td class="position">
        <xsl:value-of select="position"/>
      </td>
      <td class="description">
        <xsl:value-of select="product_description"/>
        <xsl:if test="normalize-space(url1) != ''">
          	<a href="{url1}" target="product_url">www</a> <!-- <xsl:value-of select="linktext1"/> -->
        </xsl:if>
      </td>
      <td class="thickness">
        <span class="value"><xsl:value-of select="layer_thickness"/></span>
        <span class="unit"><xsl:value-of select="layer_thickness_unit"/></span>
      </td>
<!--      
      <xsl:apply-templates 
           select="*[not(starts-with(name(),'linktext')) and not(starts-with(name(),'url')) and (name()!='layer_thickness') and (name()!='layer_thickness_unit') and (name()!='product_description') and (name()!='position') and (name()!='layer_id') and (name()!='dimensions_list') ]" 
           mode="tdvalue" />
      <td class="__dimensions_list">
        <select>
          <xsl:call-template name="tokenize_options" >
            <xsl:with-param name="text" select="dimensions_list" />
          </xsl:call-template>
        </select>
      </td>
-->	  
      <td class="density">
        <span class="value"><xsl:value-of select="density"/></span>
      </td>
    </tr>
  </xsl:template>
    
  <xsl:template match="*" mode="thvalue">
      <th class="__{name()}"> <!-- title="{name()}" -->
<!--		<xsl:value-of select="name()"/>		-->
		<xsl:call-template name="string-replace-all">
			<xsl:with-param name="text" select="name()" />
			<xsl:with-param name="replace" select="'_'" />
			<xsl:with-param name="by" select="' '" />
		</xsl:call-template>
      </th>
  </xsl:template>

  <xsl:template match="*" mode="tdvalue">
      <td class="__{name()}"> <!-- title="{name()}" -->
        <xsl:value-of select="."/>
      </td>
  </xsl:template>

</xsl:stylesheet>
</xml>
