class ThreeUtils {
  static setupApp({containerid = 'container', 
                   grid = true} = {}) {
    ThreeUtils.app = {};
    var app = ThreeUtils.app;
    app.container =  document.getElementById(containerid);
    app.renderer = ThreeUtils.setupRenderer(app.container);

    app.scene = new THREE.Scene();
    var group = new THREE.Group();
	  app.scene.add(group);
  	var light = new THREE.DirectionalLight(0xFFFFFF, 1);
	  light.position.set(100,80,130);
    group.add(light);

    var axes = new THREE.AxisHelper(600);
    app.scene.add(axes);

    var size = app.renderer.getSize();
    app.camera = new THREE.PerspectiveCamera(45, size.width / size.height, 1, 10000);
   
//    app.controls = new THREE.TrackballControls(app.camera);
//   app.controls.zoomSpeed = 0.1;

//	app.editorControls = new THREE.EditorControls( app.camera, app.container );

//zatial nie	app.transformControls = new THREE.TransformControls( app.camera, app.container );
//zatial nie	app.scene.add(app.transformControls);

	// controls

	var controls = new THREE.OrbitControls( app.camera, app.renderer.domElement );
	//controls.addEventListener( 'change', render ); // call this only in static scenes (i.e., if there is no animation loop)
	controls.enableDamping = true; // an animation loop is required when either damping or auto-rotation are enabled
	controls.dampingFactor = 1;	//0.25;
	controls.panningMode = THREE.HorizontalPanning; // default is THREE.ScreenSpacePanning
	controls.minDistance = 1;
	controls.maxDistance = 1000;
	controls.minPolarAngle = 0;
	controls.maxPolarAngle = 2*Math.PI / 2;
	app.controls = controls;


    window.addEventListener('resize', ThreeUtils.onWindowResize, false);

    var Settings = function() {
      if (grid) this.showGrid = true;
    }
  
    var settings = new Settings();
//	  app.gui = new dat.GUI({closed: true});
    if (grid) {
//      app.gui.add(settings, 'showGrid').onChange(function(value) {
//        app.grid.visible = value;
//      });
      app.grid = new LabeledGrid(100, 100, 10,[0,1,0], 0x000055, 0.2,  true, "#000000", "left");
      app.scene.add(app.grid);
	  app.grid.rotateZ(-90*Math.PI/180);
    }
    return app;
  }
  static setupRenderer(container) {
    const size = {
      width: container.clientWidth,
      height: container.clientHeight
    };
    const renderer = new THREE.WebGLRenderer({ antialias: true, alpha: true });
    renderer.setSize(size.width, size.height);
    container.appendChild(renderer.domElement);
    return renderer;
  }
  static onWindowResize(e) {
    let app = ThreeUtils.app;
    var size = {
      width: app.container.clientWidth,
      height: app.container.clientHeight
    };
	if (size.width * size.height) {	// iba ak su rozmery (t.j. napr. nie display:none)
		app.renderer.setSize(size.width, size.height);
		app.camera.aspect = size.width / size.height;
		app.camera.updateProjectionMatrix();
	}
  }
  
  static animate() {
    let app = ThreeUtils.app;
    requestAnimationFrame(ThreeUtils.animate);
//    app.editorControls.update();	// EditorControls nema update !!!
//zatial nie    app.transformControls.update();	
	app.controls.update();
    if (app.frame) app.frame();
    app.renderer.render(app.scene, app.camera);
  }
}