///<file name="appendableTable">

///<object name="AppendableTable">
///<constructor>
AppendableTable = function(evt, cfg) {
	if (!(this instanceof AppendableTable)) {
		return new AppendableTable(evt, cfg );
	}
	return this.scan(evt, cfg);
}
///</constructor>

///<instance>
///<property name="evt" type="Event"> called event </property>
///<property name="tbl" type="HTMLTableElement"> table DOM object </property>
///<property name="form" type="HTMLFormElement, Object"> form DOM object or js object holding values </property>
///<property name="defAssign" type="JSON, Array"> assignment between table and form </property>
///<property name="callbacks" type="Object"> functions for activities
///	<item name="select"> callback on select table row </item>
///</property>
///</instance>

///<prototype>
AppendableTable.prototype = {

///<property name="name" type="String">identifikacne meno objektu</property>
	name : "AppendableTable"

///<property name="_hbp" type="String">presne meno vlastnosti, zavesovanej na holderEl, ktorou sa identifikuje instancia objektu </property>
,	_hbp : '__hbp.usedObjects.AppendableTable'

	, 	init : function( cfg, callback ) {
			this.cfg = cfg || {};
			this.callbacks = cfg.callbacks || {};	// ensure object 
			this.tbl = cfg.tbl || document.querySelector('table.appendableTable');	// first classed table
			this.form = cfg.form;	// NO form accepted 
			this.defAssign = cfg.defAssign || [];
			if (this.tbl) {
				deDotter(this.tbl,this._hbp, this, true);
			}
			callback = callback || this.callbacks.init || this.no_callback;
// el==0 ... callback for doing possible needed action after init completed
			callback(0,this.form,this.tbl,this);
			return this;
		}
	,	scan : function(e, cfg) {
			var el = (e instanceof Event) ? e.currentTarget 
				: (e ? e : cfg && cfg.tbl)
			,	par = el && nearestParent(el, 'table')
			;
			var ai = deDotter(par,this._hbp);
			if (! ai) {
				ai = this.init(cfg);
			}
			ai.evt = e;
			return ai;
		}

	,	no_callback : function(el,form,tbl,instance) {
		}
		
	,	clear : function() {
			var tbody = this.tbl.querySelector('tbody')
			,	m_rows = this.tbl.dataset.minRows || 0
			;
// remove all table rows, which are not needed			
			tbody.queryXpath('./a:tr[not(contains(@class,"trpair"))][not(contains(@class,"proforma"))]', function(o, i) {			
				if (i >= m_rows) {	// index is count-1
					var nEl = o.nextElementSibling, trpair;
					o.parentNode.removeChild(o);
					while( (trpair = nEl) && trpair.classList.contains('trpair') ) {
						nEl = trpair.nextElementSibling;
						trpair.parentNode.removeChild(trpair);
					}
				}
			});
// setup all named items to default state in remaining table rows
			tbody.queryXpath('./a:tr[not(contains(@class,"proforma"))]//*[@name]', function(o, i) {
				switch(o.tagName) {
					case 'input': {
						if (o.type == 'checkbox') {
							o.checked = o.defaultChecked;
							break;
						}	// else go through
					}
					case 'select':
					case 'textarea':
						o.value = o.defaultValue;
						break;					
					default:
						o.textContent = '';
						break;					
				}
			});
		}
	,	deselect : function() {
			var id = this.tbl.id
			,	srows = this.tbl.parentNode.querySelectorAll('table#'+id+'>tbody>tr.selected')
			;
			for(var i=0;i<srows.length;i++) {
				srows[i].classList.remove('selected');
			}
		}
	,	select : function(e, callback) {
			e = e || this.evt;
			callback = callback || this.callbacks.select || this.no_callback;
			var el = (e instanceof Event) ? e.currentTarget : e
			,	nEl = el.nextElementSibling
			,	pEl = el.previousElementSibling
			,	form = this.form
			;
			this.deselect();
// find first previous NO trpair :
			while (el && el.classList.contains('trpair')) {
				el = pEl;
				pEl = pEl.previousElementSibling
			}
			if (! el) {
console.log('incorrect AppendableTable rows order !!');
				return;	
			}
			var	nEl = el.nextElementSibling
			;
			el.classList.add('selected');
// all subsequent rows classed trpair treat as THIS row
			while( (trpair = nEl) && trpair.classList.contains('trpair')) {
				trpair.classList.add('selected');
				nEl = trpair.nextElementSibling;
			}
			
			if (form) {
// kopia riadkovych udani do formulara
				this.defAssign.forEach( function(v,i,a) {
					var tel = el.querySelector(v.t)
					;
					form.elements[v.f].value = tel[v.v ? v.v : 'textContent'];
				});
			}
			callback(el,this.form,this.tbl,this);
// cascade select on parents			
			if ( (trpair = nearestParent(this.tbl,'tr')) && trpair.classList.contains('trpair')) {
				AppendableTable(trpair).select();
			}
		}
	,	create : function() {			
			var tbody = this.tbl.ownerDocument.createElement('tbody');
			tbody.innerHTML = this.cfg.rowHTML;
			return tbody.firstElementChild;
		}
	,	add : function(callback) {
			callback = callback || this.callbacks.add || this.no_callback;
			var id = this.tbl.id
			,	sel_row = this.tbl.parentNode.querySelector('table#'+id+'>tbody>tr.selected')
			,	proforma = sel_row
					|| this.tbl.parentNode.querySelector('table#'+id+'>tbody>tr.proforma')
					|| this.tbl.querySelector('tbody').lastElementChild 
					|| this.create()
			;
// cannot be trpair !			
			while(proforma && proforma.classList.contains('trpair')) {
				proforma = proforma.previousElementSibling;
			}
			var	nEl = proforma.nextElementSibling, trpair
			,	mEl = proforma.nextElementSibling
			,	new_row = proforma.cloneNode(true)
			,	form = this.form
			,	vals_ok = true
			;
// setup names and calculs
			var elNames = new_row.querySelectorAll('*[data-proforma-name]');
			for(var i=0; i < elNames.length; i++) {
				var elN = elNames[i]
				,	calc = elN.dataset.proformaCalcul
				;
				elN.setAttribute('name',elN.dataset.proformaName);
				elN.removeAttribute('data-proforma-name');
				if (calc) {
					elN.setAttribute('data-calcul',calc);
					elN.removeAttribute('data-proforma-calcul');
				}
			}
// el = index...callback for doing possible needed correction in form before storing to table row data
			callback(0,this.form,this.tbl,this);
			new_row.classList.remove('proforma');
			if (form) {
/* PROBLEM ... pomenovanie elementov v (jednom) formulari
	voci indexovanemu pomenovaniu poloziek v tabulke (v zaujme CALCUL)
	treba asi riesit odstranovanim indexacie pri prense do formularu
	a naopak spravnym indexovanim pri vkladani do tabulky.
Priklad:
	<form name="test">
	<input name="meno"/><input name="vyska"/><input name="sirka"/>	<!-- <input name="plocha"/> -->
	</form>
	<table><tbody>
	<tr><td><input name="meno_1"/></td><td><input name="vyska_1"/></td><td><input name="sirka_1"/></td>
		<td><input name="plocha_1" calcul="v(fe.vyska_1)*v(fe.sirka_1)"/></td>
	</tr>
	<tr><td><input name="meno_2"/></td><td><input name="vyska_2"/></td><td><input name="sirka_2"/></td>
		<td><input name="plocha_2" calcul="v(fe.vyska_2)*v(fe.sirka_2)"/></td>
	</tr>
	</tbody></table>
*/
				this.defAssign.forEach( function(v,i,a) {
					var el = new_row.querySelector(v.t)
					,	val = form.elements[v.f].value
			//		,	dis = form.elements[v.f].disabled
					;
					vals_ok &= ((val.trim() != '') || v.ex);	// ex ... mozne vynimky
					el[v.v ? v.v : 'textContent'] = val;
			//		if ((v.v == 'value') && dis) {
			//			el.disabled = dis;
			//		}
				});
			}
			if (vals_ok) {
				this.deselect();
				var tbody = /*proforma.parentNode*/this.tbl.querySelector('tbody')
				;
// skip trpair s:
				while (mEl && mEl.classList.contains('trpair')) {
					mEl = mEl.nextElementSibling
				}
				mEl = tbody.insertBefore(new_row,	mEl);	//sel_row && sel_row.nextElementSibling);	
// all subsequent rows classed trpair treat as THIS row
				while( (trpair = nEl) && trpair.classList.contains('trpair')) {
					nEl = trpair.nextElementSibling;
					mEl = trpair.parentNode.insertBefore( trpair.cloneNode(true), mEl.nextElementSibling );
					mEl.classList.remove('proforma');
				}				
				this.select(new_row);	//new_row.classList.add('selected');
				this.numbering();
			} else {
// el = null ...callback when not added TR because eror in data
				callback(null,this.form,this.tbl,this);
			}
// el==TR ... callback for doing possible needed action after add completed
			callback(new_row,this.form,this.tbl,this);	//	draw_fragment_vrstvy(); dragNdrop.switchRegime('_move');
			return new_row;
		}
	,	numbering: function()	{
/* Zakladom spravneho precislovania pre ucely vnorenych calculForms
je dodrziavanie zasad tvorby kalkulacnych mien a vzorcov vo forme
name="xxxxxxx_N_N_N_N"		resp.		v(fe,"xxxxxxx_N_N_N_N")
pricom kazde _N predstavuje index TR v poradi od najvyssej table.appendableTable
priklad:
	table.appendableTable
		TR	TD input name="hala2bala_1"
		TR.trpair
			table.appendableTable
				TR	TD input name="hala2bala_1_1"
				TR	TD input name="hala2bala_1_2"
				TR.trpair			
					table.appendableTable
						TR	TD input name="hala2bala_1_2_1"
						TR.trpair
							table.appendableTable
								TR	TD input name="hala2bala_1_2_1_1"
								TR	TD input name="hala2bala_1_2_1_2"
				TR.trpair			
					table.appendableTable
						TR	TD input name="hala2bala_1_2_2"
						TR.trpair
							table.appendableTable
								TR	TD input name="hala2bala_1_2_2_1"
								TR	TD input name="hala2bala_1_2_2_2"
		TR	TD input name="hala2bala_2"
*/

//	najdi tr patriace pod appendableTable:
//	$0.queryXpath(
//		'./ancestor-or-self::a:tr[parent::*/parent::a:table[contains(@class,"appendableTable")]]'
//	)
//	$0.queryXpath('./ancestor-or-self::a:tr[parent::*/parent::a:table[contains(@class,"appendableTable")]]', function(o){
//		var porad = o.queryXpath({
//						xpathExpression:'count(./preceding-sibling::a:tr)'
//						,resultType:XPathResult.NUMBER_TYPE
//					})
//		console.log(porad);
//	})
			var tbl = this.tbl
			,	highestAT = tbl.queryXpath('./ancestor-or-self::a:table[contains(@class,"appendableTable")][last()]',__,1)			
	//		,	level = $0.queryXpath({
	//				xpathExpression:'count(./ancestor-or-self::a:table[contains(@class,"appendableTable")])'
	//				,resultType:XPathResult.NUMBER_TYPE
	//			})
			,	indexes = []
			,	rgxn = /(_\d+)+$/gmi		//  abcd_1_2_3_4_5
			,	replacern = function(match) {
					var arr = match.split('_');	arr.shift();	// remove first ""	
					arr.forEach(function(v,i) {
						arr[i] = indexes[i];
					});
					return '_'+arr.join('_');
				}
			,	rgxc = /(_\d+)+\)/gmi		//  V(fe.abcd_1_2_3_4_5) * V(fe.abcd_1_2_3_4_5) 
			,	replacerc = function(match) {
					var arr = match.split(/[_\)]/);	arr.shift(); arr.pop()	// remove first and last ""	
					arr.forEach(function(v,i) {
						arr[i] = indexes[i];
					});
					return '_'+arr.join('_')+')';
				}
			,	rgxr = /(_\d+)_\\d\+/gim
			,	replacerr = function(match) {
					var arr = match.split('_');	arr.shift(); arr.pop()	// remove first "" and last "d+"	
					arr.forEach(function(v,i) {
						arr[i] = indexes[i];
					});
					return '_'+arr.join('_')+'_\\d+';
				}
			,	atr	= null	// actualy solved TR named elements
			;
			highestAT.queryXpath('.//*[@name]', function(o) {
				var tr = o.queryXpath('./ancestor-or-self::a:tr[1]',__,1);
				if (tr.classList.contains('proforma')) {	// skip named elements in TR.PROFORMA 
					return;
				}
				var	name = o.getAttribute('name'),	nname
				,	calc = o.dataset.calcul,	ncalc
				,	matches, arr
				;
				if (tr !== atr) {	// optimalization ... finding indexes only for different TR's
					atr = tr;
					indexes = [];
					tr.queryXpath('./ancestor-or-self::a:tr[parent::*/parent::a:table[contains(@class,"appendableTable")]]'
					,	function(o){
//	$0.queryXpath('./self::a:tr[not(contains(@class,"trpair"))] | ./preceding-sibling::a:tr[not(contains(@class,"proforma") or contains(@class,"trpair"))]')
							var porad = o.queryXpath({
						//		xpathExpression:'count(./preceding-sibling::a:tr)'
								xpathExpression:'count(./self::a:tr[not(contains(@class,"trpair"))] | ./preceding-sibling::a:tr[not(contains(@class,"proforma") or contains(@class,"trpair"))])'
							,	resultType:XPathResult.NUMBER_TYPE
							})
							indexes.push(porad);	//console.log(porad);
					})
				}
				nname = name.replace(rgxn, replacern);
				if (name != nname) {
					o.setAttribute('name', nname);
				}
				if (calc) {
					ncalc = calc.replace(rgxc, replacerc);
					ncalc = ncalc.replace(rgxr, replacerr);
					if (calc != ncalc) {
						o.dataset.calcul = ncalc;
					}
				}
			});
/*			if (tbl !== highestAT) {	// simple make ALWAYS totally from highest level
				AppendableTable(highestAT).numbering();
			} else {
				var renumber = function(nameEl, rgxpn, rgxpc) {
					nameEl.setAttribute('name', nameEl.getAttribute('name').replace(rgxpn,'_'+(i+1)) );
					var calc = nameEl.dataset.calcul;
					if (calc) {
						nameEl.dataset.calcul = calc.replace(rgxpc,'_'+(i+1)+')');
					}
				}
				var	id = this.tbl.id
				,	trs = this.tbl.parentNode.querySelectorAll('table#'+id+'>tbody>tr') || []
			//	,	$0.queryXpath('./../../../a:tr')
				,	rgxpn = /_(\d+)$/gmi
				,	rgxpc = /_(\d+)\)/gmi
				for (var i=0; i<trs.length; i++) {
					var els = trs[i].querySelectorAll('*[name]') || []
					for (var j=0; j<els.length; j++) {
						els[j].setAttribute('name', els[j].getAttribute('name').replace(rgxpn,'_'+(i+1)) );
						var calc = els[j].dataset.calcul;
						if (calc) {
							els[j].dataset.calcul = calc.replace(rgxpc,'_'+(i+1)+')');
						}
					}
				}
			}	*/
		}
	,	hv_pairs : function(e, all) {	// hide/view subtables
			e = e || this.evt;
			var bt = e.currentTarget
			,	disp = bt.style.backgroundColor != ''
			;
			if (all) {
// state	color				desc
//	0		aquamarine CSS		trpairs opened only tfoot
//	1		cadetblue			trpairs opened all (thead tbody tfoot)
//	2		white				trpairs closed all (thead tbody tfoot)	
//	TODO ... it is relatively complicated algorithm !!!
				var tbl = nearestParent(bt,'table')
				,	trs = tbl.querySelectorAll('tbody tr.trpair')
				,	alls = tbl.querySelectorAll('button.opener.alls')
				;
				for (var i=0; i<trs.length; i++) {
					trs[i].style.display = disp ? '' : 'none';
				}
				for (var i=0; i<alls.length; i++) {
					alls[i].style.backgroundColor = disp ? '' : 'cadetblue';
				}
			} else {
				var tr = e.currentTarget.parentNode.parentNode
				,	nEl = tr.nextElementSibling, trpair
				;
				while( (trpair = nEl) && trpair.classList.contains('trpair') ) {
					trpair.style.display = '';
					var hb = trpair.querySelectorAll('thead,tbody');
					for (var i=0; i<hb.length; i++) {
						hb[i].style.display = disp ? 'none' : '';
					}
					nEl = trpair.nextElementSibling;
				}
				bt.style.backgroundColor = disp ? '' : 'cadetblue';
			}
		}
	,	remove : function(e, callback) {
			e = e || this.evt;
			callback = callback || this.callbacks.remove || this.no_callback;
			var m_rows = this.tbl.dataset.minRows || 0
			,	id = this.tbl.id
			,	a_rows = this.tbl.parentNode.querySelectorAll('table#'+id+'>tbody>tr:not([class^=trpair])').length
			;
			if (a_rows <= m_rows) {
// el = null ...callback when not removed TR because limits
				callback(null,this.form,this.tbl,this);
				return;
			}
			var	tr = e.currentTarget.parentNode.parentNode;
			this.select( tr );
			var me = this;
			setTimeout( function() {	// aby sa stihol oznacit riadok !
				var naozaj = confirm("Naozaj odstrániť položku ?\n (Niet cesty späť)");
				if (!naozaj) {
					return;
				}
				var	sel = tr.classList.contains('selected')
				,	nEl = tr.nextElementSibling, trpair
				,	pEl = tr.previousElementSibling
				;
				tr.parentNode.removeChild(tr);
	// all subsequent rows classed trpair treat as THIS row
				while( (trpair = nEl) && trpair.classList.contains('trpair')) {
					nEl = trpair.nextElementSibling;
					trpair.parentNode.removeChild(trpair);
				}
				
				if (sel) {
					if (nEl) {
						nEl.classList.add('selected');
					} else if (pEl && ( ! pEl.classList.contains('proforma') )) {
						pEl.classList.add('selected');
					}
				}
				me.numbering();
	// el==TR ... callback for doing possible needed action after remove completed
				callback(tr,this.form,this.tbl,this);
			}, 10);
			e.stopPropagation();	// aby nesiel do oznacenia riadku !
		}
	,	move_up : function(e, callback) {
			e = e || this.evt;
			callback = callback || this.callbacks.move_up || this.no_callback;
			var tr = e.currentTarget.parentNode.parentNode, mEl
			,	pEl = tr.previousElementSibling
			,	nEl = tr.nextElementSibling, trpair
			;
// skip trpair s:
			while (pEl && pEl.classList.contains('trpair')) {
				pEl = pEl.previousElementSibling
			}
			if ( pEl && ! pEl.classList.contains('proforma') ) {	
				mEl = tr.parentNode.insertBefore( tr, pEl );
				while ((trpair = nEl) && trpair.classList.contains('trpair')) {
					nEl = trpair.nextElementSibling;
					mEl = trpair.parentNode.insertBefore( trpair, mEl.nextElementSibling );
				}
			}
			this.numbering();
			e.stopPropagation();	// disable select row !
			callback(tr,this.form,this.tbl,this);
		}
	,	move_down : function(e, callback) {
			e = e || this.evt;
			callback = callback || this.callbacks.move_down || this.no_callback;
			var tr = e.currentTarget.parentNode.parentNode, mEl
			,	nEl = tr.nextElementSibling, trpair
			,	toEl = nEl
			;
// skip tr's own trpair s:	
			while (toEl && toEl.classList.contains('trpair')) {
				toEl = toEl.nextElementSibling
			}
			if (toEl) {	
// but now we must skip toEl's own trpair s !
				trpair = toEl;
				do{ trpair = trpair.nextElementSibling;
					if (trpair && trpair.classList.contains('trpair')) {
						toEl = trpair;
					} else break;
				} while (1); 
			
				mEl = tr.parentNode.insertBefore( tr, toEl.nextElementSibling );
				while ((trpair = nEl) && trpair.classList.contains('trpair')) {
					nEl = trpair.nextElementSibling;
					mEl = trpair.parentNode.insertBefore( trpair, mEl.nextElementSibling );
				}
			}
			this.numbering();
			e.stopPropagation();	// disable select row !
			callback(tr,this.form,this.tbl,this);
		}
	,	valueChange : function(e, callback) {
			e = e || this.evt;
			callback = callback || this.callbacks.change || this.no_callback;
			e = e || this.evt;
			var el = (e instanceof Event) ? e.currentTarget : e;
			callback(el,this.form,this.tbl,this);
		}
	,	read : function() {
// alert('AppendableTable.read not provided yet !');	return;
			var arr = []
			,	id = this.tbl.id
			,	rows = this.tbl.parentNode.querySelectorAll('table#'+id+'>tbody>tr')
			,	r, rgxp=/.*_(\d+)$/gmi, match
			;
			for (var i = 0; i < rows.length; i++) {
				if (rows[i].classList.contains('proforma')) {
					continue;
				}
				var obj = {}; 
				if (this.defAssign && this.defAssign.length) {
					this.defAssign.forEach( function(v,i,a) {
						var el = rows[i].querySelector(v.t);
						if (v.np) {
							obj[v.f] = el[v.v ? v.v : 'textContent'];
						} else {
							obj[v.f] = parseFloat( el[v.v ? v.v : 'textContent'] );
						}
					});
					r = i+1;
				} else {
					rows[i].queryXpath('(.//a:input | .//a:select | .//a:textarea)[@name]', function(o,i) {
						rgxp.lastIndex = 0;
						if (match = rgxp.exec(o.name)) {
							r = match[1];	// row index identification
						}
						obj[o.name] = {
							el: o
						,	val: o.value
						};
					})
				}
				arr[r] = obj;	//arr.push(obj);
			}
			return { name: this.tbl.id, arr: arr };
		}
	,	write : function( arr, callback ) {
alert('AppendableTable.write not provided yet !');	return;
		//	arr = arr || [this.fragment_project.vrstvy;
			callback = callback || this.callbacks.writer || this.no_callback;
			this.clear();
			var form = this.form;
			if (form) {
				try {
					for (var r = 0; r < arr.length; r++) {
						this.defAssign.forEach( function(v,i,a) {
							form.elements[v.f].value = arr[r][v.f];
							if (typeof v.wc == 'function') {
								v.wc( form.elements[v.f] );
							}
						});
// el = index...callback for doing possible needed correction in form after filling by table row data
						callback(	r	   ,this.form,this.tbl,this);
						var new_row = this.add();
// el = TR	... callback for doing possible needed action after ading row data
						callback( new_row  ,this.form,this.tbl,this);
					}
				} catch(e) {
// el==NULL ... callback on error while writing data
					callback( null  ,this.form,this.tbl,this);
				}
			}
// el=='' ... callback for doing possible needed action after write completed
			callback( ''  ,this.form,this.tbl,this);
		}
	}
///</prototype>


///<section name="using and utitities">

function clearAll_AppendableTables() {
	document.body.queryXpath('.//a:table[contains(@class,"appendableTable")]', function(o) {
		AppendableTable(o).clear();
	});
}


///</file>