/** remove duplicates from ONLY numeric or string arrays	//ATTENTION ... from end to start !!!
 * @ngdoc function
 * @name removeDups
 * @function
 *
 * @description	remove duplicates from ONLY numeric or string arrays	//ATTENTION ... from end to start !!!
 * Calling sequences:
 *	var arr = [1,2,1,3,4,5,1,2,8]
 *	removeDups(arr);	// arr === [3, 4, 5, 1, 2, 8]
 *	var arr = ["1","2","1","3","4","5","1","2","8"]
 *	removeDups(arr);	// arr === ["1","2","1","3","4","5","1","2","8"]
 * @param {array} stringArray Array of Strings or Numbers to be cleared from duplicates.
 * @returns {array} Array of Strings or Numbers to be cleared from duplicates.
**/
function removeDups(stringArray) { //remove duplicates from ONLY numeric or string arrays !!!
	if (stringArray) {
		var index = {};
		// traverse array from end to start 
		// so removing the current item from the array
		// doesn't mess up the traversal
		for (var i = stringArray.length - 1; i >= 0; i--) {
			if (stringArray[i] in index) {
				stringArray.splice(i, 1);	// remove this item
			} else {
				index[stringArray[i]] = true;	// add this value to index
			}
		}
	}
	return stringArray;
}

/** jednoduchy nahradzovac (templater) ##NIECO## ... solve it
 * @ngdoc function
 * @name wildcardsSolver
 * @function
 *
 * @description	jednoduchy nahradzovac (templater) ##NIECO## ... solve it!
 * Najde vsetky vyskyty parov ##....## a nahradi ich formou:
 *	##expression##		... expression												myE = 12			##myE##			12
 *	##F=expression##	... (function(){"+expression+"})()	//expected RETURN !!!	myE = "return 12"	##F=myE##		12
 *	##F:expression##	... eval(expression+";")									myE = "12*1"		##F:myE##		12
 * @param {string} potFn expression (viz above).
 * @returns {string} solved expression.
**/
///<function name="deDotter">
///<param name="obj">parent object to search in</param>
///<param name="dotted" type="String">dotted string expression (like a normal call) </param>
///<param name="value" optional="optional">value to assign</param>
///<param name="force" type="Boolean" optional="optional">
/// undefined ... no create path
/// defined ... unconditionally create path
/// true ... ove 
/// false ... delete , but only if value is undefined
///</param>

/*# Skutocne ma uz trapilo zlozite generovanie objektov formou
	// chcem vytvorit objekt window._hbp.commands.first.list
  if (typeof window._hbp == 'undefined') { window._hbp = {}; }
  if (typeof window._hbp.commands == 'undefined') { window._hbp.commands = {}; }
  if (typeof window._hbp.commands.first == 'undefined') { window._hbp.commands.first = {}; }
  if (typeof window._hbp.commands.first.list == 'undefined') { window._hbp.commands.first.list = {}; }
 Nahradzujem to jednoduchym: 
	
Vyber hodnoty bez vytvarania:
	deDotter(window,'_hbp.commands.first.list');	// ak neexistuje, vrati undefined
Prepis hodnoty bez vytvarania:
	deDotter(window,'_hbp.commands.second.list',{});	// ak neexistuje, vrati undefined
Vymazanie hodnoty (bez vytvorenia cesty)
	deDotter(window,'_hbp.commands.third.list',undefined);	// vrati undefined
	
Vyber hodnoty s vytvorenim bez prepisu, pokial existuje:
	deDotter(window,'_hbp.commands.first.list', {}, false);	// vrati {}, vznikne window._hbp.commands.first.list
Prepis hodnoty s vytvorenim:
	deDotter(window,'_hbp.commands.second.list',{}, true);	// vrati {}, vznikne window._hbp.commands.second.list
Vymazanie hodnoty (s vytvorenim cesty)
	deDotter(window,'_hbp.commands.third.list',undefined,);	// vrati undefined
	
Vyber hodnoty s vytvorenim len ak neexistuje:
	deDotter(window,'_hbp.commands.first.list', {}, false);	// vrati {}, vznikne window._hbp.commands.first.list
Prepis hodnoty s vytvorenim:
	deDotter(window,'_hbp.commands.second.list',{}, true);	// vrati {}, vznikne window._hbp.commands.second.list
Vymazanie hodnoty (s vytvorenim cesty)
	deDotter(window,'_hbp.commands.third.list',undefined,);	// vrati undefined

	
Okrem standartneho skratenia pisania umoznuje tato funkcia aj generovat
objekt, pokial je (akolvek) definovany parameter force.
Pokial je exaktne false a value = undefined, posledna vlastnost je vymazana
*/
/*		var ObjMy = {};
		deDotter(ObjMy,'hopsa.hejsa.do.Brandejsa', 1234);		//... undefined,  ObjMy={}
		deDotter(ObjMy,'hopsa.hejsa.do.Brandejsa', 1234, true);	//... 1234,  ObjMy={hopsa:{hejsa:{do:{Brandejsa:1234}}}}
*/
function deDotter(obj, dotted, value, force, purge) {
	obj = obj || window;
	var adots = isArr(dotted) ? dotted : dotted.split('.')
	,	aobj = obj
	,	parObj = obj
	,	prop = obj
	,	signal_purge = false;
	;
	if (! obj || !dotted) {
		return undefined;
	}
	for(var i=0; i < adots.length; i++) {
		if ((i < adots.length - 1) && isNul(aobj) ) {
/*# pokial dosiahneme primitivu, nezavisle na force KONCIME !
Primitivu nemozem prestavovat ? 
*/		
			if (! force) {
				return aobj;
			} else {	// ??? nasilne stvoreny objekt miesto primitivy ? 
				parObj[adots[i-1]] = {};
				aobj = parObj[adots[i-1]];
			}
		}
		if ( !isDef(aobj[adots[i]]) ) {
/*# set dotted value even if not exists already
Pokial property neexistuje, standartne sa vrati undefined, bez ohladu na value
pokial je vsak definovane (akokolvek) force, vytvori sa dana property
( Problem nastane, pokial je aktualna property v ceste primitiva,
ktorej sa neda vytvorit vnorena vlastnost. (x= 5; x.o ={}; isDef(x.o) //false)
 V takom pripade, pokial je definovane force (bezpodmiencne vytvor cestu)
 primitivna vlastnost sa BEZOHLADNE prepise na OBJECT 
) 
*/
			if ( ! isDef(force)) {
				return undefined;
			} else {
				aobj[adots[i]] = {};
				if ( ! isDef(aobj[adots[i]]) ) {	// aobj is primitive !
					aobj = parObj[adots[i-1]] = {};
					aobj[adots[i]] = {};
				}
			}
		}
/*# ked uspesne dosiahneme poslednu uroven, ide o spracovanie value:
pokial je force explicitne TRUE
	prepis aktualnu hodnotu (pokial value === undefined, property sa zmaze)
pokial je force nedefinovane:
	ak je definovany parameter value , prepis aktualnu hodnotu
	inak proste preber aktualnu hodnotu
pokial je force explicitne FALSE
	pokial aktualna hodnota existuje, nebude sa nasilne prepisovat
*/
		if (i == adots.length - 1) {
			if (isDef(value)) {
//# value is defined, force ... true,  OVERWRITE property
//# value is defined, force ... undefined,  OVERWRITE property
//# value is defined, force ... false,  KEEP_OLD property
				if (force !== false) {
					aobj[adots[i]] = value;	
				}
//# value ... undefined, force ... true  ,  DELETE property
			} else if (force === true) {
				delete aobj[adots[i]];
if (isEmp(aobj)) {
	signal_purge = true;
}
			}
		}
		parObj = aobj;
		aobj = aobj[adots[i]];
// co urobit, ked teraz aobj == undefined, aobj == null ?		
	}
	if (signal_purge && purge) {
		adots.pop();
		aobj = deDotter(obj, adots.join('.'), /*value*/undefined, /*force*/true, /*purge*/ true);
	}
	return aobj;	// return value (after set)
}
// deDotter helpers:
dD = {
	get : function(obj, dotted) {
		return deDotter(obj, dotted);
	}
,	set : function(obj, dotted, value) {
		return deDotter(obj, dotted, value);
	}
,	del : function(obj, dotted) {
		return deDotter(obj, dotted, undefined, true);
	}
,	purge : function(obj, dotted) {
		return deDotter(obj, dotted, undefined, true, true);
	}
,	make : function(obj, dotted, value) {
		return deDotter(obj, dotted, value, true);
	}
}

function wildcardsSolver(potFn, calcul, unsolved) {	
	var potFnE = ""
	,	orig_potFn = potFn
	,	is_function = false
	;
	if ( isStr(potFn) ) {
		if ( potFn.match(/^F[\:\=]/) ) {
			is_function = true;
			potFnE = potFn;
			switch (potFn[1]) {
				case ":":
					potFnE = "(function(){"+potFnE+"})()";
				case "=":
					potFn=eval(potFnE+";");
					break;
			}
		} else {
			potFn = deDotter(calcul, potFn);
		}
	}
	var EpotFn = potFn;
	if ( isFnc(potFn) ) {
		EpotFn = potFn();
	} 
	if ( ! isDef(EpotFn) ) {
		if (!isDef(unsolved)) {	// ak unsolved je nedefinovane, ponecham original aj s ##
			EpotFn = "##"+orig_potFn+"##";
		} else if ( isFnc(unsolved) ) {	// ak unsolved je funkcia, vykonam
			unsolved(potFn, calcul, orig_potFn, is_function);
		} else {	// inak osadim to, co je v unsolved
			EpotFn = unsolved;
		}
	}
	return EpotFn;
}

function wildTempsSolver(query, calcul, unsolved, errback, dry_run) {	
	var rex = /##[^#]*##/g;	
	var exar = query.match(rex); 
	if (exar) {
		removeDups(exar);
		if (dry_run) {
			return exar;
/*
wildTempsSolver('ahoj ##fero## aj ty ##F:2*jano##',__,__,__,true);	// dry_run=true
["##fero##", "##F:2*jano##"]			// exar array
*/
		}
		for (var i=0; i < exar.length; i++) {
			var clientSideVal = exar[i].replace(/##/g,'');
			try {
				var rtxt = wildcardsSolver(clientSideVal, calcul, unsolved);	
				var rep = new RegExp('##'+encodeRE(clientSideVal)+'##', "g");
	//			query = query.replace(rep,rtxt);
	/* POZOR replace pracuje s nahradnymi znakmi :
Pattern	Inserts
$$	Inserts a "$".
$&	Inserts the matched substring.
$`	Inserts the portion of the string that precedes the matched substring.
$'	Inserts the portion of the string that follows the matched substring.
$n	Where n is a non-negative integer lesser than 100, 
	inserts the nth parenthesized submatch string, 
	provided the first argument was a RegExp object.	
*/
				var replacerW = function (match, offset, string) {
//					var pred = string.substr(0,offset)
//					,	za = string.substr(offset+match.length)
//					;
//					return pred+rtxt+za;
					return rtxt;
				};
				query = query.replace(rep, replacerW);
			} catch(e) {
				if (isFnc(errback)) {
					errback(e, clientSideVal);
				}
				return false;
			}
		}
	}
	return query;
}
/** Pokus o no-need-data-semantic TEMPLATEr
 *	s pouzitim mojho	wildcardsSolver - a
 *				a		wildTempsSolver - a
 *	na principe nahradzovania v case definicie template vlastne neznamych dat
 *	pomcou STANDART regexp replace zastupnych znakov:
 *	_________________________________________________
 *			STRING.replace(REGEXP,"..$$....$&...$`......$'.....$1....$21345.....")
 *		$$			Inserts a "$".
 *		$&			Inserts the matched substring.
 *		$`			Inserts the portion of the string that precedes the matched substring.
 *		$'			Inserts the portion of the string that follows the matched substring.
 *		$n or $nn	Where n or nn are decimal digits, 
 *					inserts the nth parenthesized submatch string, provided the first argument was a RegExp object.
 *
 *	@param {array}		templates	- pole pouzitych templates
 *	@param {object}		calcul		- datovy objekt (MODEL)
 *
 *	@param {function}	unsolved	- optional funkcia, vyvolana, pokial wildXXXsolver nie je schopny zistit hodnotu
 *	@param {string}		unsolved		variantne string, ktorym sa osadi hodnota miesto default "undefined"
 *
 *	@param {function}	errback		- optional funkcia, vyvolana v pripade EXCEPTION pocas renderovania template
**/
///<example>

/*
	var templateRules = {
		"ul" : "<h3>##$[1]##>/h3>"
	,	"a" : "<span style='width:100px;font-weight:bold;'>##.$## :</span>##=$[1]##"
	,	"b" : "<span style='width:100px;font-weight:bold;'>##.$## :<input type='checkbox' checked='##.$[1]##'</span>##=$##"
	}
	var template = "						\
<ul>Options									\
	<li>##!ul!url##<li>						\
	<ul>opt									\
		<li>##!a!opt.element##</li>			\
		<li>##!a!opt.property##</li>		\
		<li>##!a!opt.id##</li>				\
		<li>##!a!opt.transformer##</li>		\
		<li>##!a!opt.checker##</li>			\
		<li>##!a!opt.checkedEl##</li>		\
		flags:								\
		<li>##!b!opt.reloadIt##</li>		\
		<li>##!b!opt.replaceIt##</li>		\
		<li>##!b!opt.evaluateIt##</li>		\
		<li>##!b!opt.debugIt##</li>			\
		xhr:								\
		<li>##!a!opt.method##</li>		\
		<li>##!a!opt.params##</li>			\
		<li>##!a!opt.callback##</li>		\
		<li>##!a!opt.scope##</li>			\
		<li>##!a!opt.waiting##</li>			\
		<li>##!a!opt.noLog##</li>			\
	</ul>									\
</ul>										\
";
	return wildTemplater(template, templateRules, this, "???");	//, callback, errback) 

*/

///</example>
//_______________________________________________________________
function wildTemplater( template, rules, calcul, unsolved, errback) {

	//var rexRule = /##([\.=-]){0,1}\$(?:\[(\d+)\]){0,1}([^#]*)##/g;	// $===.$[0] value	....##.$[99]pppp##....
	var rexRule = /##([\.=-]){0,1}\$(\d+)*([^#]*)##/g;					// $===.$0 value    =$ tag   ????  -$ escaped value ????
	function ruleDecoder(ruleTxt, propTxt) {
		var aProp = propTxt.split(",");
		var preRule = ruleTxt.replace(rexRule, function(matches, p1, p2, p3) {
// returns:
//Num	Index	Match	1			2			3
// 0	37	##$[1]##	undefined	1			[zero-length string]
// 1	106	##.$##		.			undefined	[zero-length string]
// 2	121	##=$[1]##	=			1			[zero-length string]
// 3	186	##.$##		.			undefined	[zero-length string]
// 4	226	##.$[1]##	.			1			[zero-length string]
// 5	243	##=$##		=			undefined	[zero-length string]
					var retval = ""
					,	item = aProp[parseInt(p2 || 0, 10)]		// propertiesArray[index]
					;
					if (item) {			
						switch(p1) {
							case "=":	//	tagName
								retval = item;
								break;
				//			case "-":	//	force html escape of value  ... IT MUST SOLVER TO DO !!!
				//				retval = "##"+item+"##";		//retval = "##F:encodeXml(?????)##";
				//				break;
							default:	// '' , '.' value
								retval = "##"+item+"##";	
								break;
						}
					}
					return retval + p3;	// any appendix goes with
				}
			)
		return preRule;
	}
	
	var rex = /##!([\w\d]+)!([^#]*)##/g;	//  ....##!xxx!ppp,pp,pp##....	can contain multiple props, comma delimited
	var query = template.replace(rex,function(matches, p1, p2) {
//returns:
//Num	Index	Match											1	2
// 0	27	##!ul!url##										ul	url
// 1	75	##!a!opt.element,opt.fff,F=2*3,F:return 5*14##	a	opt.element,opt.fff,F=2*3,F:return 5*14
// 2	137	##!a!opt.property##								a	opt.property
// 3	171	##!a!opt.id##									a	opt.id
// 4	201	##!a!opt.transformer##							a	opt.transformer
// 5	238	##!a!opt.checker##								a	opt.checker
				var retval = "";
				if (rules[p1]) {
					retval = ruleDecoder(rules[p1], p2);
				} //LET IT BE	 else { throw new SyntaxError('template rule not known');	}
				return retval;
			}
		)
	var out = wildTempsSolver(query, calcul, unsolved, errback);
	return out;
}

///<from file="/X3Dmodels/code/test_inline_deer1.js" original="gen_blender_vars_form">
function gen_wildcards_form( codeTxt, frm_or_data, predefs ) {
	var vrs = []
//	,	decoderRgxp = /(?:(\w+?)\_)*([^=]+)(?:=(.+))*/
/*	"FLOAT_fero_x=12.345".match(/(?:(\w+?)\_)+?(.*)/)
	["FLOAT_fero_x=12.345", "FLOAT", "fero_x", "12.345"]
*/
	,	decoderRgxp = /(?:(\w+?)\_)+?(.*)/
/*	"FLOAT_fero_x".match(/(?:(\w+?)\_)+?(.*)/)
	["FLOAT_fero_x", "FLOAT", "fero_x"]
*/
	,	odoc,frmt,spn,txt,inp,dfltv
	,	frm = isELE(frm_or_data) ? frm_or_data : null
	,	calcul = frm ? null : frm_or_data
	; 
//# poziadame wildTempsSolver o zoznam pozadovanych premennych do pola (v)a(r)iable(s)
	wildTempsSolver( codeTxt, calcul
		,	function(potFn, calcul, orig_potFn, is_function){ 
				if (!is_function) {
					vrs.push(orig_potFn); //alert(o);
				}
			}
	); 
/*# DOBRE BY BOLO do formulara OSADIT aj to, co je v JSON_DATA_DEFINITION (predefs) samotnom,
 nielen to co wildTempsSolver najde vo forme ##.....## poloziek,
 ( teoreticky by bolo mozne uvazovat tak, ze formularom zadavatelne budu iba tie
 explicitne formou ##polozka## vyjadene polozky), ale asi by to stratilo na univerzalite
*/	
	if (predefs) {
		vrs = vrs.concat(gopn(predefs, ''));
		vrs = vrs.filter (function (v, i, a) { return a.indexOf (v) == i });
	}

//# pokial bola poziadavka priamo osadit data (miesto formularoveho rucneho zadania)
//# vyplnime, a osetrime iba pripadne chybajuce paramatre
	if (! frm) {
		if (vrs.length) {
			alert(MISSING_PARAMETERS);
		}
		return;
	}
//# vymazeme aktualny obsah formularu
	frm.innerHTML = '';
	odoc = frm.ownerDocument;
//# a priamo naplname formular so snahou o identifikaciu druhu premennej 
//# pokial je pomenovana format_hocico_hocico_hocico, rozobratim regexp-om
	for (var i=0, dfltv=0; i<vrs.length; i++) {
		frmt = vrs[i].match(decoderRgxp);
		spn = frm.appendChild(odoc.createElement('span'));
		txt = spn.appendChild(odoc.createTextNode(vrs[i]));	//(frmt[2]));
		switch( frmt && frmt.length > 2 && frmt[1].toLowerCase() ) {
			case 'bool':	
			case 'boolean':	
				inp = frm.appendChild(odoc.createElement('input'));
				inp.setAttribute('type','checkbox');
				break;
			case 'int':		
			case 'integer':		
				inp = frm.appendChild(odoc.createElement('input'));
				inp.setAttribute('type','number');
				inp.setAttribute('step','1');
				break;
			case 'float':
				inp = frm.appendChild(odoc.createElement('input'));
				inp.setAttribute('type','number');
				break;
			case 'text':
			case 'string':
				inp = frm.appendChild(odoc.createElement('input'));
				dfltv = '';
				break;
			default : 
				inp = frm.appendChild(odoc.createElement('textarea'));
		}
		inp.setAttribute('name',vrs[i]);
//		inp.setAttribute('value',frmt && frmt[3] || dfltv);
//		inp.setAttribute('value',JSON_DATA_DEFINITION && deDotter(JSON_DATA_DEFINITION, vrs[i]) || dfltv);
		inp.value = predefs && deDotter(predefs, vrs[i]) || dfltv;
		frm.appendChild(odoc.createElement('br'));
	}
	return vrs.length;
}
///</from>

