///<file name="eventer.js">
///<clone from="UI_forms.js" "changes="none"/>

/*
function simulateClick() {
  var evt = document.createEvent("MouseEvents");
  evt.initMouseEvent("click", true, true, window,
    0, 0, 0, 0, 0, false, false, false, false, 0, null);
  var cb = document.getElementById("checkbox"); 
  var canceled = !cb.dispatchEvent(evt);
  if(canceled) {
    // A handler called preventDefault
    alert("canceled");
  } else {
    // None of the handlers called preventDefault
    alert("not canceled");
  }
}
*/
/*global*/aGenEvent_eval = true;
function aGenEvent(element, typeArg, eventType, /*optionalObj*/ params, /*optional*/eventName, /*optional*/memo){
/* event interfaces:		http://www.w3.org/TR/DOM-Level-2-Events/events.html#Events-eventgroupings
	UIEvent		event = document.createEvent("UIEvents");
		// Introduced in DOM Level 2:
		interface UIEvent : Event {
		  readonly attribute views::AbstractView  view;
		  readonly attribute long             detail;
		  void               initUIEvent(in DOMString typeArg, 
										 in boolean canBubbleArg, 
										 in boolean cancelableArg, 
										 in views::AbstractView viewArg, 
										 in long detailArg);
		};
		DOMFocusIn		The DOMFocusIn event occurs when an EventTarget receives focus, 
						for instance via a pointing device being moved onto an element 
						or by tabbing navigation to the element. 
						Unlike the HTML event focus, DOMFocusIn can be applied to any focusable EventTarget, 
						not just FORM controls.
		DOMFocusOut		The DOMFocusOut event occurs when a EventTarget loses focus, 
						for instance via a pointing device being moved out of an element 
						or by tabbing navigation out of the element. 
						Unlike the HTML event blur, DOMFocusOut can be applied to any focusable EventTarget, 
						not just FORM controls.
		DOMActivate		The activate event occurs when an element is activated, 
						for instance, thru a mouse click or a keypress. 
						A numerical argument is provided to give an indication of the type of activation that occurs: 
							1 for a simple activation (e.g. a simple click or Enter), 
							2 for hyperactivation (for instance a double click or Shift Enter).
		
	MouseEvent	event = document.createEvent("MouseEvents");
		// Introduced in DOM Level 2:
		interface MouseEvent : UIEvent {
		  readonly attribute long             screenX;
		  readonly attribute long             screenY;
		  readonly attribute long             clientX;
		  readonly attribute long             clientY;
		  readonly attribute boolean          ctrlKey;
		  readonly attribute boolean          shiftKey;
		  readonly attribute boolean          altKey;
		  readonly attribute boolean          metaKey;
		  readonly attribute unsigned short   button;
		  readonly attribute EventTarget      relatedTarget;
		  void               initMouseEvent(in DOMString typeArg, 
											in boolean canBubbleArg, 
											in boolean cancelableArg, 
											in views::AbstractView viewArg, 
											in long detailArg, 
											in long screenXArg, 
											in long screenYArg, 
											in long clientXArg, 
											in long clientYArg, 
											in boolean ctrlKeyArg, 
											in boolean altKeyArg, 
											in boolean shiftKeyArg, 
											in boolean metaKeyArg, 
											in unsigned short buttonArg, 
											in EventTarget relatedTargetArg);
		};
	click		The click event occurs when the pointing device button is clicked over an element. 
				A click is defined as a mousedown and mouseup over the same screen location. 
				The sequence of these events is:
					mousedown
					mouseup
					click
				If multiple clicks occur at the same screen location, the sequence repeats with 
				the detail attribute incrementing with each repetition. 
				This event is valid for most elements.
	mousedown	The mousedown event occurs when the pointing device button is pressed over an element. 
				This event is valid for most elements.
	mouseup		The mouseup event occurs when the pointing device button is released over an element. 
				This event is valid for most elements.
	mouseover	The mouseover event occurs when the pointing device is moved onto an element. 
				This event is valid for most elements.
	mousemove	The mousemove event occurs when the pointing device is moved while it is over an element. 
				This event is valid for most elements.
	mouseout	The mouseout event occurs when the pointing device is moved away from an element. 
				This event is valid for most elements..
	
	KeyEvent	event = document.createEvent("MouseEvents");
		????
		
	MutationEvent	event = document.createEvent("MutationEvents");
		// Introduced in DOM Level 2:
		interface MutationEvent : Event {

		  // attrChangeType
		  const unsigned short      MODIFICATION                   = 1;
		  const unsigned short      ADDITION                       = 2;
		  const unsigned short      REMOVAL                        = 3;

		  readonly attribute Node             relatedNode;
		  readonly attribute DOMString        prevValue;
		  readonly attribute DOMString        newValue;
		  readonly attribute DOMString        attrName;
		  readonly attribute unsigned short   attrChange;
		  void               initMutationEvent(in DOMString typeArg, 
											   in boolean canBubbleArg, 
											   in boolean cancelableArg, 
											   in Node relatedNodeArg, 
											   in DOMString prevValueArg, 
											   in DOMString newValueArg, 
											   in DOMString attrNameArg, 
											   in unsigned short attrChangeArg);
		};
	DOMSubtreeModified
	DOMNodeInserted
	DOMNodeRemoved
	DOMNodeRemovedFromDocument
	DOMNodeInsertedIntoDocument
	DOMAttrModified
	DOMCharacterDataModified
	
	HTMLEvent	event = document.createEvent("HTMLEvents");

	load		The load event occurs when the DOM implementation finishes 
				loading all content within a document, 
				all frames within a FRAMESET, 
				or an OBJECT element.
	unload		The unload event occurs when the DOM implementation removes 
				a document from a window or frame. 
				This event is valid for 
					BODY and FRAMESET elements.
	abort		The abort event occurs when page loading is stopped 
				before an image has been allowed to completely load. 
				This event applies to 
					OBJECT elements.
	error		The error event occurs when an image does not load properly 
				or when an error occurs during script execution. 
				This event is valid for 
					OBJECT elements, BODY elements, and FRAMESET element.
	select		The select event occurs when a user selects some text in a text field. 
				This event is valid for 
					INPUT and TEXTAREA elements.
	change		The change event occurs when a control loses the input focus 
				and its value has been modified since gaining focus. 
				This event is valid for 
					INPUT, SELECT, and TEXTAREA. element.
	submit		The submit event occurs when a form is submitted. 
				This event only applies to the 
					FORM element.
	reset		The reset event occurs when a form is reset. 
				This event only applies to the 
					FORM element.
	focus		The focus event occurs when an element receives focus either 
				via a pointing device or by tabbing navigation. 
				This event is valid for the following elements: 
					LABEL, INPUT, SELECT, TEXTAREA, and BUTTON.
	blur		The blur event occurs when an element loses focus either 
				via the pointing device or by tabbing navigation. 
				This event is valid for the following elements: 
					LABEL, INPUT, SELECT, TEXTAREA, and BUTTON.
	resize		The resize event occurs when a document view is resized.
	scroll		The scroll event occurs when a document view is scrolled.
	
*/
/*
    if (document.createEventObject){
        // dispatch for IE
        var evt = document.createEventObject();
        return element.fireEvent('on'+eventType,evt)
    }
    else{
        // dispatch for firefox + others
        var evt = document.createEvent("HTMLEvents");
        evt.initEvent(eventType, true, true ); // event type,bubbling,cancelable
        return !element.dispatchEvent(evt);
    }
*/
	var evDef = {	// according http://www.w3.org/TR/DOM-Level-3-Events
/* 
// Event Constructor Syntax:
[Constructor(DOMString typeArg, optional EventInit eventInitDict)]
partial interface Event
{
};

// Suggested initEvent initializer:
dictionary EventInit {
  boolean bubbles    = false;
  boolean cancelable = false;
};
*/
			CustomEvent : {	typeArg : []
			,	args : {
					bubbles : true	//false
				,	cancelable : true	//false
				,	detail : null
				}
			,	initParms : ['bubbles','cancelable']
			}
/*

// Event Constructor Syntax:
[Constructor(DOMString typeArg, optional CustomEventInit customEventInitDict)]
partial interface CustomEvent
{
  // Originally introduced (and deprecated) in DOM Level 3:
  void initCustomEvent(DOMString typeArg,
                       boolean canBubbleArg,
                       boolean cancelableArg,
                       any detailArg);
};

// Suggested initCustomEvent replacement initializer:
dictionary CustomEventInit {
  // Attributes from Event:
  boolean bubbles    = false;
  boolean cancelable = false;

  // Attributes for CustomEvent:
  any     detail     = null;
};
*/
		,	UIEvent : {	typeArg : ['DOMActivate','load','unload','abort','error','select','resize','scroll']
			,	args : {
					bubbles : true	//false
				,	cancelable : true	//false
				,	view : null
				,	detail : 0
				}
			,	initParms : ['bubbles','cancelable','view','detail']
			}
/*

// Event Constructor Syntax:
[Constructor(DOMString typeArg, optional UIEventInit dictUIEventInit)]
partial interface UIEvent
{
};

// Suggested initUIEvent replacement initializer:
dictionary UIEventInit {
  // Attributes from Event:
  boolean       bubbles    = false;
  boolean       cancelable = false;

  // Attributes for UIEvent:
  AbstractView? view       = null;
  long          detail     = 0;
};
*/
		,	FocusEvent : {	typeArg : ['blur','DOMFocusIn','DOMFocusOut','focus','focusin','focusout']
			,	args : {
					bubbles : true	//false
				,	cancelable : true	//false
				,	view : null
				,	detail : 0
				,	relatedTarget : null
			,	initParms : ['bubbles','cancelable','view','detail','relatedTarget']
			}
		}
/*
// Event Constructor Syntax:
[Constructor(DOMString typeArg, optional FocusEventInit focusEventInitDict)]
partial interface FocusEvent
{
  // Originally introduced (and deprecated) in DOM Level 3:
  void initFocusEvent(DOMString typeArg,
                      boolean canBubbleArg,
                      boolean cancelableArg,
                      AbstractView? viewArg,
                      long detailArg,
                      EventTarget? relatedTargetArg);
};

// Suggested initFocusEvent replacement initializer:
dictionary FocusEventInit {
  // Attributes from Event:
  boolean       bubbles       = false;
  boolean       cancelable    = false;

  // Attributes from UIEvent:
  AbstractView? view          = null;
  long          detail        = 0;

  // Attributes for FocusEvent:
  EventTarget?  relatedTarget = null;
};
*/
		,	MouseEvent : {	typeArg : ['click','dblclick','mousedown','mouseenter','mouseleave','mousemove','mouseout','mouseover','mouseup']
			,	args : {
					bubbles : true	//false
				,	cancelable : true	//false
				,	view : null
				,	detail : 0
				,	screenX : 0
				,	screenY : 0
				,	clientX : 0
				,	clientY : 0
				,	ctrlKey : false
				,	shiftKey : false
				,	altKey  : false
				,	metaKey : false
				,	button  : 0
	  // Note: "buttons" was not previously initializable through initMouseEvent!
				,	buttons : 0
				,	relatedTarget : null
				}
			,	initParms : ['bubbles','cancelable','view','detail','screenX','screenY','clientX','clientY','ctrlKey','shiftKey','altKey','metaKey','button','relatedTarget']
			}
/*
// Event Constructor Syntax:
[Constructor(DOMString typeArg, optional MouseEventInit mouseEventInitDict)]
partial interface MouseEvent
{
};

// Suggested initMouseEvent replacement initializer:
dictionary MouseEventInit {
  // Attributes from Event:
  boolean        bubbles       = false;
  boolean        cancelable    = false;

  // Attributes from UIEvent:
  AbstractView?  view          = null;
  long           detail        = 0;

  // Attributes for MouseEvent:
  long           screenX       = 0;
  long           screenY       = 0;
  long           clientX       = 0;
  long           clientY       = 0;
  boolean        ctrlKey       = false;
  boolean        shiftKey      = false;
  boolean        altKey        = false;
  boolean        metaKey       = false;
  unsigned short button        = 0;
  // Note: "buttons" was not previously initializable through initMouseEvent!
  unsigned short buttons       = 0;
  EventTarget?   relatedTarget = null;
};
*/
		,	WheelEvent : {	typeArg : ['wheel']
			,	args : {
					bubbles : true	//false
				,	cancelable : true	//false
				,	view : null
				,	detail : 0
				,	screenX : 0
				,	screenY : 0
				,	clientX : 0
				,	clientY : 0
				,	ctrlKey : false
				,	shiftKey : false
				,	altKey  : false
				,	metaKey : false
				,	button  : 0
	  // Note: "buttons" was not previously initializable through initMouseEvent!
				,	buttons : 0
				,	relatedTarget : null
				,	deltaX : 0
				,	deltaY : 0
				,	deltaZ : 0
				,	deltaMode : 0
				}
			,	initParms : ['bubbles','cancelable','view','detail','screenX','screenY','clientX','clientY','ctrlKey','shiftKey','altKey','metaKey','button','relatedTarget','deltaX','deltaY','deltaZ','deltaMode']
			}
/*
// Event Constructor Syntax:
[Constructor(DOMString typeArg, optional WheelEventInit wheelEventInitDict)]
partial interface WheelEvent
{
  // Originally introduced (and deprecated) in DOM Level 3:
  void initWheelEvent(DOMString typeArg,
                      boolean canBubbleArg,
                      boolean cancelableArg,
                      AbstractView? viewArg,
                      long detailArg,
                      long screenXArg,
                      long screenYArg,
                      long clientXArg,
                      long clientYArg,
                      unsigned short buttonArg,
                      EventTarget? relatedTargetArg,
                      DOMString modifiersListArg,
                      double deltaXArg,
                      double deltaYArg,
                      double deltaZArg,
                      unsigned long deltaMode);
};

// Suggested initWheelEvent replacement initializer:
dictionary WheelEventInit {
  // Attributes from Event:
  boolean        bubbles       = false;
  boolean        cancelable    = false;

  // Attributes from UIEvent:
  AbstractView?  view          = null;
  long           detail        = 0;

  // Attributes from MouseEvent:
  long           screenX       = 0;
  long           screenY       = 0;
  long           clientX       = 0;
  long           clientY       = 0;
  boolean        ctrlKey       = false;
  boolean        shiftKey      = false;
  boolean        altKey        = false;
  boolean        metaKey       = false;
  unsigned short button        = 0;
  // Note: "buttons" was not previously initializable through initMouseEvent!
  unsigned short buttons       = 0;
  EventTarget?   relatedTarget = null;

  // Attributes for WheelEvent:
  double          deltaX        = 0.0;
  double          deltaY        = 0.0;
  double          deltaZ        = 0.0;
  unsigned long  deltaMode     = 0;
};
*/
		,	KeyboardEvent : {	typeArg : ['keydown','keypress','keyup']
			,	args : {
					bubbles : true	//false
				,	cancelable : true	//false
				,	view : null
				,	detail : 0
				,	'char' : ""
				,	key : ""
				,	location : 0
				,	ctrlKey : false
				,	shiftKey : false
				,	altKey  : false
				,	metaKey : false
				,	repeat  : false
				,	locale : ""
				,	charCode : 0
				,	keyCode : 0
				,	which : 0
				}
			,	initParms : ['bubbles','cancelable','view','detail','char','key','location','ctrlKey','shiftKey','altKey','metaKey','repeat','locale','charCode','keyCode','which']
			}
/*
// Event Constructor Syntax:
[Constructor(DOMString typeArg, optional KeyboardEventInit keyboardEventInitDict)]
partial interface KeyboardEvent
{
  // Originally introduced (and deprecated) in DOM Level 3:
  void initKeyboardEvent(DOMString typeArg,
                         boolean canBubbleArg,
                         boolean cancelableArg,
                         AbstractView? viewArg,
                         DOMString charArg,
                         DOMString keyArg,
                         unsigned long locationArg,
                         DOMString modifiersListArg,
                         boolean repeat,
                         DOMString localeArg);
};

// Suggested initKeyboardEvent replacement initializer:
dictionary KeyboardEventInit {
  // Attributes from Event:
  boolean       bubbles    = false;
  boolean       cancelable = false;

  // Attributes from UIEvent:
  AbstractView? view       = null;
  long          detail     = 0;

  // Attributes for KeyboardEvent:
  DOMString     char       = "";
  DOMString     key        = "";
  unsigned long location   = 0;
  boolean       ctrlKey    = false;
  boolean       shiftKey   = false;
  boolean       altKey     = false;
  boolean       metaKey    = false;
  boolean       repeat     = false;
  DOMString     locale     = "";

  // (Legacy) key attributes for KeyboardEvent:
  unsigned long charCode   = 0;
  unsigned long keyCode    = 0;
  unsigned long which      = 0;
};
*/
		,	CompositionEvent : {	typeArg : ['compositionstart','compositionupdate','compositionend']
			,	args : {
					bubbles : true	//false
				,	cancelable : true	//false
				,	view : null
				,	detail : 0
				,	data  : null
				,	locale : ""
				}
			,	initParms : ['bubbles','cancelable','view','detail','data','locale']
			}
/*
// Event Constructor Syntax:
[Constructor(DOMString typeArg, optional CompositionEventInit compositionEventInitDict)]
partial interface CompositionEvent
{
  // Originally introduced (and deprecated) in DOM Level 3:
  void initCompositionEvent(DOMString typeArg,
                         boolean canBubbleArg,
                         boolean cancelableArg,
                         AbstractView? viewArg,
                         DOMString? dataArg,
                         DOMString localeArg);
};

// Suggested initCompositionEvent replacement initializer:
dictionary CompositionEventInit {
  // Attributes from Event:
  boolean       bubbles    = false;
  boolean       cancelable = false;

  // Attributes from UIEvent:
  AbstractView? view       = null;
  long          detail     = 0;

  // Attributes for CompositionEvent:
  DOMString?    data       = null;
  DOMString     locale     = "";
};
*/
	//	,	MutationEvent : {
	//			typeArg : ['DOMAttrModified','DOMCharacterDataModified','DOMNodeInserted','DOMNodeInsertedIntoDocument','DOMNodeRemoved','DOMNodeRemovedFromDocument','DOMSubtreeModified']
	//		}
			//obsolete, use MutationObserver
		}	// otherwise "CustomEvent"
	,	eT, eventC, eparms ={}, initParms =[], pVal;
	if ( ! evDef[eventType] ) {	// scan for appropriate eventType based on typeArg
		for (var p in evDef) {
			eT = evDef[p];
			if (eT.typeArg.indexOf(typeArg.toLowerCase()) != -1) {
				eventType = p;
				break;
			}
		}
	}
	if ( ! evDef[eventType] ) {	// if nothing found after scan , use CustomEvent
		eventType = 'CustomEvent'; 
	}
	initParms = evDef[eventType].initParms;
	for (var pa in evDef[eventType].args) {
		if (pa != 'typeArg') {
			pVal = (params && isDef(params[pa])) ? params[pa] : evDef[eventType].args[pa];
			eparms[pa] = pVal;
		}
	}
/* MDN:
//modern way (not in IE)
	var event = new Event('build');
	// Listen for the event.
	elem.addEventListener('build', function (e) { ... }, false);
	// Dispatch the event.
	elem.dispatchEvent(event);

//old way	// Warning: This way of creating events is deprecated. Use event constructors instead.
	// Create the event.
	var event = document.createEvent('Event');
	// Define that the event name is 'build'.
	event.initEvent('build', true, true);
	// Listen for the event.
	document.addEventListener('build', function (e) {
	  // e.target matches document from above
	}, false);
	// target can be any Element or other EventTarget.
	document.dispatchEvent(event);
*/

	// use Event constructor:    var event = new CustomEvent('build', { 'detail': elem.dataset.time });
	if (aGenEvent_eval) {
		try {
			eval("eventC = new "+eventType+"('"+typeArg+"', eparms)");
		} catch(e) {
			aGenEvent_eval = false;
		}
	}
	if (! aGenEvent_eval) {
		eventC = document.createEvent(eventType);
		var iParms = [];
		for (var i=0; i<initParms.length; i++) {
			iParms.push(eparms[initParms[i]]);
		}
		Event.prototype.initEvent.apply(eventC,iParms);
	}
	return eventC;
}
function aExecuteEvent(element, typeArg) {	//! vykonaj funkciu, priradenu ako event pozadovanemu elementu
	//! TODO ... pomocou monitora addEventListener zabezpec vykonanie aj touto formou priradenych event-ov
	// C:\xampp\htdocs\LIBRARY\GETSET\eventsList.js
	var eventC = aGenEvent(element, typeArg);
}
function aFireEvent(element, typeArg, eventType, /*optionalObj*/ params, /*optional*/eventName, /*optional*/memo){
	var eventC = aGenEvent(element, typeArg, eventType, /*optionalObj*/ params, /*optional*/eventName, /*optional*/memo);
	element.dispatchEvent(eventC);
/*
	  if (document.createEvent) {
		event = document.createEvent("HTMLEvents");
		event.initEvent(eventType, true, true);
	  } else {
		event = document.createEventObject();
		event.eventType = eventType;
	  }

	  event.eventName = eventName;
	  event.memo = memo || { };

	  if (document.createEvent) {
		element.dispatchEvent(event);
	  } else {
		element.fireEvent("on" + event.eventType, event);
	  }
*/
}
//function fireMousEvent(element, eventType, /*optional*/eventName, /*optional*/memo, clbk ) {
//	var evt = document.createEvent("MouseEvents");
//	evt.initMouseEvent("click", true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
//	element.dispatchEvent(evt);
//}


///</file>